// Code by Dave Warker, thanks again!

#import "AppDelegate.h"

@implementation RJCAppDelegate

- (BOOL)application:(UIApplication*)application didFinishLaunchingWithOptions:(NSDictionary*)launchOptions
{
    // NOTE: iOS 9.0 and later require that the keyWindow have a root view controller when didFinishLaunchingWithOptions: exits
    // or the app fails with an exception. As of 2015-12-15 (64 bit Otto drop 5) Director does not do that. Until Adobe fixes this
    // problem we have to assign a temp view controller here when running on 9.0 or later. Thus the following ugliness just so we
    // can build with Xcode 7 or later and have access to iOS 9 APIs.
    
    BOOL ok = [super application: application didFinishLaunchingWithOptions: launchOptions];
    if (ok && [[[UIDevice currentDevice] systemVersion] compare: @"9.0" options: NSNumericSearch] != NSOrderedAscending)
    {
        UIWindow* win = [[UIApplication sharedApplication] keyWindow];
        if (win && !win.rootViewController)
            win.rootViewController = [[UIViewController new] autorelease];
    }
	
	// Register the supported interaction types.
	UIUserNotificationType types =
		UIUserNotificationTypeBadge |
		UIUserNotificationTypeSound |
		UIUserNotificationTypeAlert;
	
	// 
	UIUserNotificationSettings *mySettings = [UIUserNotificationSettings settingsForTypes:types categories:nil];
	[[UIApplication sharedApplication] registerUserNotificationSettings:mySettings];
	
	return ok;
	
}

@end